package com.seeyon.ctp.organization.controller;

import com.seeyon.apps.collaboration.manager.ColManager;
import com.seeyon.ctp.common.AppContext;
import com.seeyon.ctp.common.authenticate.domain.User;
import com.seeyon.ctp.common.controller.BaseController;
import com.seeyon.ctp.organization.OrgConstants;
import com.seeyon.ctp.organization.OrgConstants.Role_NAME;
import com.seeyon.ctp.organization.manager.OrgManager;
import com.seeyon.ctp.organization.manager.OrgManagerDirect;
import com.seeyon.ctp.organization.po.OrgMember;
import com.seeyon.ctp.util.Strings;
import com.seeyon.ctp.util.annotation.CheckRoleAccess;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.springframework.web.servlet.ModelAndView;

import java.util.List;

@CheckRoleAccess(
        roleTypes = {Role_NAME.GroupAdmin, Role_NAME.AccountAdministrator, Role_NAME.HrAdmin, Role_NAME.SystemAdmin}
)
public class LevelController extends BaseController {
    protected OrgManager orgManager;
    protected OrgManagerDirect orgManagerDirect;

    private ColManager colManager;

    public ColManager getColManager() {
        if (this.colManager == null) {
            this.colManager = (ColManager)AppContext.getBean("colManager");
        }

        return this.colManager;
    }

    public void setColManager(ColManager colManager) {
        this.colManager = colManager;
    }

    public LevelController() {
    }

    public OrgManager getOrgManager() {
        return this.orgManager;
    }

    public void setOrgManager(OrgManager orgManager) {
        this.orgManager = orgManager;
    }

    public OrgManagerDirect getOrgManagerDirect() {
        return this.orgManagerDirect;
    }

    public void setOrgManagerDirect(OrgManagerDirect orgManagerDirect) {
        this.orgManagerDirect = orgManagerDirect;
    }

    public ModelAndView showLevelframe(HttpServletRequest request, HttpServletResponse response) throws Exception {
        ModelAndView mav = new ModelAndView("apps/organization/level/listLevel");
        Long accountId = AppContext.currentAccountId();
        String accountIdStr = request.getParameter("accountId");
        if (Strings.isNotBlank(accountIdStr)) {
            accountId = Long.valueOf(accountIdStr);
        }
        User user = AppContext.getCurrentUser();
        if(user.getName().equals("系统管理员")){
            List<OrgMember> acc = colManager.selectacc("单位管理员");
            OrgMember use= acc.get(0);
            accountId = use.getOrgAccountId();
        }
        mav.addObject("accountId", accountId);
        mav.addObject("isGroup", OrgConstants.GROUPID.equals(accountId));
        return mav;
    }
}
